#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private AB3030PowerReversal[] cacheAB3030PowerReversal;

		
		public AB3030PowerReversal AB3030PowerReversal(int longerTimeframe, double thresholdOpen, double thresholdClose, double thresholdBodySize, double thresholdRejectionSize, double thresholdRejectionMultiple)
		{
			return AB3030PowerReversal(Input, longerTimeframe, thresholdOpen, thresholdClose, thresholdBodySize, thresholdRejectionSize, thresholdRejectionMultiple);
		}


		
		public AB3030PowerReversal AB3030PowerReversal(ISeries<double> input, int longerTimeframe, double thresholdOpen, double thresholdClose, double thresholdBodySize, double thresholdRejectionSize, double thresholdRejectionMultiple)
		{
			if (cacheAB3030PowerReversal != null)
				for (int idx = 0; idx < cacheAB3030PowerReversal.Length; idx++)
					if (cacheAB3030PowerReversal[idx].LongerTimeframe == longerTimeframe && cacheAB3030PowerReversal[idx].ThresholdOpen == thresholdOpen && cacheAB3030PowerReversal[idx].ThresholdClose == thresholdClose && cacheAB3030PowerReversal[idx].ThresholdBodySize == thresholdBodySize && cacheAB3030PowerReversal[idx].ThresholdRejectionSize == thresholdRejectionSize && cacheAB3030PowerReversal[idx].ThresholdRejectionMultiple == thresholdRejectionMultiple && cacheAB3030PowerReversal[idx].EqualsInput(input))
						return cacheAB3030PowerReversal[idx];
			return CacheIndicator<AB3030PowerReversal>(new AB3030PowerReversal(){ LongerTimeframe = longerTimeframe, ThresholdOpen = thresholdOpen, ThresholdClose = thresholdClose, ThresholdBodySize = thresholdBodySize, ThresholdRejectionSize = thresholdRejectionSize, ThresholdRejectionMultiple = thresholdRejectionMultiple }, input, ref cacheAB3030PowerReversal);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.AB3030PowerReversal AB3030PowerReversal(int longerTimeframe, double thresholdOpen, double thresholdClose, double thresholdBodySize, double thresholdRejectionSize, double thresholdRejectionMultiple)
		{
			return indicator.AB3030PowerReversal(Input, longerTimeframe, thresholdOpen, thresholdClose, thresholdBodySize, thresholdRejectionSize, thresholdRejectionMultiple);
		}


		
		public Indicators.AB3030PowerReversal AB3030PowerReversal(ISeries<double> input , int longerTimeframe, double thresholdOpen, double thresholdClose, double thresholdBodySize, double thresholdRejectionSize, double thresholdRejectionMultiple)
		{
			return indicator.AB3030PowerReversal(input, longerTimeframe, thresholdOpen, thresholdClose, thresholdBodySize, thresholdRejectionSize, thresholdRejectionMultiple);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.AB3030PowerReversal AB3030PowerReversal(int longerTimeframe, double thresholdOpen, double thresholdClose, double thresholdBodySize, double thresholdRejectionSize, double thresholdRejectionMultiple)
		{
			return indicator.AB3030PowerReversal(Input, longerTimeframe, thresholdOpen, thresholdClose, thresholdBodySize, thresholdRejectionSize, thresholdRejectionMultiple);
		}


		
		public Indicators.AB3030PowerReversal AB3030PowerReversal(ISeries<double> input , int longerTimeframe, double thresholdOpen, double thresholdClose, double thresholdBodySize, double thresholdRejectionSize, double thresholdRejectionMultiple)
		{
			return indicator.AB3030PowerReversal(input, longerTimeframe, thresholdOpen, thresholdClose, thresholdBodySize, thresholdRejectionSize, thresholdRejectionMultiple);
		}

	}
}

#endregion
